<?php

namespace Modules\Pd\Http\Controllers;

use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\DB;
use Modules\Hr\Entities\EmployeeSite;
use Modules\Pd\Entities\PallatizingAttachment;
use Modules\Pd\Entities\PallatizingData;
use Modules\Pd\Entities\PallatizingEmployee;
use Modules\Pd\Entities\PallatizingHeader;
use Modules\Pp\Entities\CustomerOrder;

class PallatizingListController extends Controller
{


    public function allPallatizingData()
    {
        try {
            $query = 'SELECT *FROM pd_pallatizing_headers ORDER BY pallatizing_header_id DESC';
            $pallets = DB::select($query);
            $responseBody = $this->responseBody(true, "PallatizingListController", "allPallatizingData", $pallets);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "PallatizingListController", "allPallatizingData", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }




    public function deletePallet($id)
    {
        try {
            $pallet = PallatizingHeader::find($id);

            if ($pallet->delete()) {
                /** DELETE PALLATIZING DATA*/
                $pallet_data = PallatizingData::where('pallatizing_header_id', '=', $id)->get();
                foreach ($pallet_data as $data) {
                    PallatizingData::find($data->pallatizing_data_id)->delete();
                }
                /**END OF DELETE PALLATIZING DATA */


                /** DELETE PALLATIZING EMPLOYEE */
                $pallet_employee = PallatizingEmployee::where('pallatizing_header_id', '=', $id)->get();
                foreach ($pallet_employee as $employee) {
                    PallatizingEmployee::find($employee->pallatizing_employee_id)->delete();
                }
                /**END OF DELETE PALLATIZING EMPLOYEE */


                /** DELETE PALLATIZING ATTACHMNET */
                $pallet_attachment = PallatizingAttachment::where('pallatizing_header_id', '=', $id)->get();
                foreach ($pallet_attachment as $attachment) {
                    PallatizingAttachment::find($attachment->pallatizing_attachment_id)->delete();
                }
                /**END OF DELETE PALLATIZING ATTACHMNET */
            }

            $responseBody = $this->responseBody(true, "PallatizingListController", "deletePallet", true);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "PallatizingListController", "deletePallet", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }


    public function pallatizingPrint($id)
    {
        try {
            $pallatizing_header = PallatizingHeader::find($id);
            $pallatizing_header->po = "";
            $pallatizing_header->order_name = "";
            $pallatizing_header->factory = "";
            $pallatizing_header->employees = "";
            $pallatizing_header->Layer1 = 0;
            $pallatizing_header->Layer2 = 0;
            $pallatizing_header->Layer3 = 0;
            $pallatizing_header->Layer4 = 0;
            $pallatizing_header->Layer5 = 0;
            $pallatizing_header->Layer6 = 0;
            $pallatizing_header->Layer7 = 0;
            $pallatizing_header->Layer8 = 0;
            $pallatizing_header->Layer9 = 0;
            $pallatizing_header->Layer10 = 0;
            $pallatizing_header->Layer11 = 0;
            $pallatizing_header->Layer12 = 0;
            $pallatizing_header->Layer13 = 0;
            $pallatizing_header->Layer14 = 0;
            $pallatizing_header->Layer15 = 0;
            $pallatizing_header->total_psc = 0;

            $query = 'SELECT pd_pallatizing_employees.employee_id
            FROM pd_pallatizing_employees WHERE pd_pallatizing_employees.pallatizing_header_id = "' . $id . '"';
            $employee_result = DB::select($query);

            $query = 'SELECT pd_pallatizing_data.*
            FROM pd_pallatizing_data WHERE pd_pallatizing_data.pallatizing_header_id = "' . $id . '"';
            $data_result = DB::select($query);



            $employees = "";
            foreach ($employee_result as $emp) {
                $employees .= $emp->employee_id . ",";
            }
            $pallatizing_header->employees = $employees;


            $total_psc = 0;
            foreach ($data_result as $data) {
                $pallatizing_header[$data->layer] = $data->total;
                $pallatizing_header->total_psc+= $data->total;
            }

            $order = CustomerOrder::find($pallatizing_header->order_id);
            if ($order) {
                $pallatizing_header->po = $order->purchase_order;
                $pallatizing_header->order_name = $order->customer_name;
                $pallatizing_header->factory = $order->factory_po_num;
            }
            $factory = EmployeeSite::find($pallatizing_header->factory_id);
            if ($factory) {
                $pallatizing_header->factory = $factory->site;
            }


            $responseBody = $this->responseBody(true, "PallatizingListController", "pallatizingPrint", $pallatizing_header);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "PallatizingListController", "pallatizingPrint", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }


    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
